//+------------------------------------------------------------------+
//|                                                 SqDSSBressert.mq4|
//|                            Copyright © @2021 StrategyQuant s.r.o.|
//|                                     http://www.strategyquant.com |
//+------------------------------------------------------------------+
#property  copyright "Copyright © @2021 StrategyQuant s.r.o."
#property  link      "http://www.strategyquant.com"

//---- indicator settings
#property  indicator_separate_window;
#property  indicator_buffers 2
#property  indicator_color1  Blue
#property  indicator_width1  1
#property  indicator_color2  Yellow

//----
extern int StochPeriod=10;
extern int EMAPeriod=9;
extern int TriggerPeriod=5;
//---- buffers
double MitBuffer[],DssBuffer[],TriggerBuffer[];
double IndiBuffer[];



//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(3);
   SetIndexStyle(0,DRAW_LINE);
   
   SetIndexStyle(1,DRAW_LINE);
    SetIndexStyle(2,DRAW_NONE);

   //SetIndexDrawBegin(0,Lenght);
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);
   SetIndexBuffer(0,DssBuffer,INDICATOR_DATA);
   SetIndexBuffer(1,TriggerBuffer,INDICATOR_DATA);
   SetIndexBuffer(2,MitBuffer,INDICATOR_CALCULATIONS);

   IndicatorShortName("SqDSSBressert("+StochPeriod+","+EMAPeriod+","+TriggerPeriod+")");

   return(0);
  }

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int start()
  {
   int i, limit;
   int counted_bars=IndicatorCounted();
   if(counted_bars>0)
      counted_bars--;
   limit=Bars-counted_bars;
   
   double highest,lowest,stoch,fs;
   double MIT, delta;
   double highRange,lowRange;
   double smooth_coefficient = 2.0 / (1.0 + EMAPeriod);
   

   for(i=limit-1; i>=0; i--)
   
     {
         
            highest =  High[iHighest(NULL,0,MODE_HIGH,StochPeriod,i)];
            lowest = Low[iLowest(NULL,0,MODE_LOW,StochPeriod,i)];

            delta = Close[i] - lowest;
            if((highest - lowest)!=0){
            
               MIT = delta/(highest - lowest)*100.0;
            }
            MitBuffer[i] = smooth_coefficient * (MIT - MitBuffer[i+1]) + MitBuffer[i+1];       

     }
     
     
    double DSS;
      for (i = limit-1; i >= 0; i--)
      {
         highRange = MitBuffer[ArrayMaximum(MitBuffer, StochPeriod, i)];
         lowRange = MitBuffer[ArrayMinimum(MitBuffer, StochPeriod, i)];
         
         delta = MitBuffer[i] - lowRange;
         
         if((highRange - lowRange)!=0){
            DSS = delta/(highRange - lowRange)*100.0;
            }
         DssBuffer[i] = smooth_coefficient * (DSS - DssBuffer[i+1]) + DssBuffer[i+1];
      }
      
      
      
      for (i = limit-1; i >= 0; i--){
      
        TriggerBuffer[i]=iMAOnArray(DssBuffer,0,TriggerPeriod,0,MODE_EMA,i);

      }
      
    
   return(0);
  }

